[PATCH] overlay/038: fix impure xattr test

[Date Prev] [Date Next] [Thread Prev] [Thread Next] [Date Index] [Thread Index]



On kvm-xfstest, getfattr (2.4.43) does not return failure exit code
when the requested xattr is not found.

Change the test to check the returned xattr value instead of exit code.

Cc: Chandan Rajendra <chandan@xxxxxxxxxxxxxxxxxx>
Signed-off-by: Amir Goldstein <amir73il@xxxxxxxxx>
---

Eryu,

This test is supposed to pass on master now and it does pass on my
Ubuntu 16.04, but fails on kvm-xfstests (Debian stretch).

The failure is due to different behavior of getfattr on different
systems and as a result of me suggesting to Chandan to check getfattr
exit code. So this patch is for my redemption ;-)

I surveyed for other places that check exit code of getfattr as
indication of ENODATA and found only one other instance in
_require_scratch_richacl_support() (for non xfs/ext4 FSTYP).
However, this instance is buggy regardless, because it provides no
file argument to getfattr.
I would fix it, but I am not sure what's the semantics and have no
idea how to test this.

Amir.


 tests/overlay/038 | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

diff --git a/tests/overlay/038 b/tests/overlay/038
index 24cd432..69fd76a 100755
--- a/tests/overlay/038
+++ b/tests/overlay/038
@@ -108,9 +108,9 @@ test_file_st_ino=$(stat -c '%i' $SCRATCH_MNT/test_file)
 
 mv $SCRATCH_MNT/test_file $impure_dir
 
-$GETFATTR_PROG --absolute-names -n 'trusted.overlay.impure' \
-	       $upperdir/test_dir/impure_dir >>$seqres.full 2>&1
-[[ $? == 0 ]] || echo "Impure directory missing impure xattr"
+impure=$($GETFATTR_PROG --absolute-names --only-values -n 'trusted.overlay.impure' \
+			$upperdir/test_dir/impure_dir)
+[[ $impure == "y" ]] || echo "Impure directory missing impure xattr"
 
 # After $impure_dir becomes impure
 parent_d=$($here/src/t_dir_type $impure_dir $impure_dir_parent_st_ino)
@@ -133,9 +133,9 @@ rm -rf $impure_dir/test_file
 $here/src/t_dir_type $impure_dir $test_file_st_ino
 [[ $? != 0 ]] || echo "Directory's readdir cache has stale entries"
 
-$GETFATTR_PROG --absolute-names -n 'trusted.overlay.impure' \
-	       $upperdir/test_dir/impure_dir >>$seqres.full 2>&1
-[[ $? != 0 ]] || echo "Pure directory has impure xattr"
+impure=$($GETFATTR_PROG --absolute-names --only-values -n 'trusted.overlay.impure' \
+			$upperdir/test_dir/impure_dir 2>/dev/null)
+[[ -z $impure ]] || echo "Pure directory has impure xattr"
 
 # Verify d_ino values corresponding to "." and ".." entries of a
 # pure lower dir.
-- 
2.7.4

--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@xxxxxxxxxxxxxxx
More majordomo info at  http://vger.kernel.org/majordomo-info.html



[Index of Archives]     [Linux Filesystems Development]     [Linux NFS]     [Linux NILFS]     [Linux USB Devel]     [Linux Audio Users]     [Yosemite News]     [Linux Kernel]     [Linux SCSI]

  Powered by Linux